import 'package:aibiblegames/pages/ChatScreen.dart';
import 'package:aibiblegames/utils/CommonUtils.dart';
import 'package:carousel_slider/carousel_slider.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:url_launcher/url_launcher.dart';
import '../utils/MyColors.dart';
import '../utils/MyStyles.dart';

class GamesScreen extends StatefulWidget{
  @override
  State<StatefulWidget> createState(){
    return GamesScreenState();
  }
}
class GamesScreenState extends State<GamesScreen>{
  TextEditingController userNameController = TextEditingController();
  int pageMode = 0;
  @override
  void initState(){
    super.initState();
  }
  @override
  Widget build(BuildContext context) {
    return Scaffold(
        body: Container(
          decoration: BoxDecoration(
              color: Colors.black,
              image: DecorationImage(
                  image: AssetImage("assets/images/background/bg3.png"),
                  fit: BoxFit.cover)),
          child: Stack(
            children: [
              // Button in the top-left corner
              Align(
                alignment: Alignment.topLeft,
                child: Padding(
                  padding: EdgeInsets.all(16.0),
                  child: Row(
                    children: [
                      GestureDetector(
                        onTap: () {
                          Navigator.of(context).pop();
                        },
                        child: Stack(
                          children: [
                            SizedBox(
                              width: 50,
                              height: 50,
                              child: Image.asset(
                                'assets/bg_btn_back.png',
                                fit: BoxFit.contain,
                              ),
                            )
                          ],
                        ),
                      ),
                      Expanded(child: SizedBox()),
                      GestureDetector(
                        onTap: () async{
                          final Uri url = Uri.parse('https://aibiblegames.com/instructions/');
                          if (!await launchUrl(url)) {
                            throw Exception('Could not launch $url');
                          }
                        },
                        child: Stack(
                          children: [
                            SizedBox(
                              width: 50,
                              height: 50,
                              child: Image.asset(
                                'assets/bg_circle_button.png',
                                fit: BoxFit.contain,
                              ),
                            ),
                            SizedBox(
                              width: 50,
                              height: 50,
                              child: Center(
                                child: Icon(Icons.list, size: 35,color: MyColors.iconCOlor,),
                              ),
                            )
                          ],
                        ),
                      ),
                      SizedBox(width: 10,),
                      GestureDetector(
                        onTap: () async{
                          final Uri url = Uri.parse('https://aibiblegames.com/demo.mp4');
                          if (!await launchUrl(url)) {
                          throw Exception('Could not launch $url');
                          }
                        },
                        child: Stack(
                          children: [
                            SizedBox(
                              width: 50,
                              height: 50,
                              child: Image.asset(
                                'assets/bg_circle_button.png',
                                fit: BoxFit.contain,
                              ),
                            ),
                            SizedBox(
                              width: 50,
                              height: 50,
                              child: Center(
                                child: Icon(Icons.play_arrow, size: 35,color: MyColors.iconCOlor,),
                              ),
                            )
                          ],
                        ),
                      )
                    ],
                  ),
                ),
              ),
              // Text at the bottom center
              Center(
                child: Align(
                  alignment:Alignment.bottomCenter,
                  child: Container(
                    padding: EdgeInsets.all(50),
                    child: Column(
                      mainAxisSize: MainAxisSize.min,
                      children: <Widget>[
                        Text('SCRIPTURE\nSESSIONS', style: const TextStyle(
                            fontSize: 50, color: Colors.white, fontFamily: 'Jomhuria', height: 0.5), textAlign: TextAlign.center,),
                        Center(child: GestureDetector(
                          onTap: () async{
                            String userName = await _showUsernameInputDialog(context);
                            if(userName.isNotEmpty){
                              Navigator.push(
                                context,
                                MaterialPageRoute(
                                  builder: (_) => ChatScreen(gameMode: 'paid',userName:userName, gameTitle: 'Adult Game'),
                                ),
                              );
                            }

                          },
                          child: Stack(
                            children: [
                              SizedBox(
                                width: 200,
                                height: 50,
                                child: Image.asset(
                                  'assets/bg_btn.png',
                                  fit: BoxFit.contain,
                                ),
                              ),
                              SizedBox(
                                width: 200,
                                height: 50,
                                child: Center(
                                  child: Text('ADULT GAME', style: MyStyles.primaryButtonStyle,),
                                ),
                              )
                            ],
                          ),
                        ),),
                        SizedBox(height: 20,),
                        Center(child: GestureDetector(
                          onTap: () async{
                            String userName = await _showUsernameInputDialog(context);
                            if(userName.isNotEmpty){
                              Navigator.push(
                                context,
                                MaterialPageRoute(
                                  builder: (_) => ChatScreen(gameMode: 'paid',userName:userName, gameTitle: 'Child Game', promptUrl: 'https://aibiblegames.com/gp2/jesus28.txt',),
                                ),
                              );
                            }

                          },
                          child: Stack(
                            children: [
                              SizedBox(
                                width: 200,
                                height: 50,
                                child: Image.asset(
                                  'assets/bg_btn.png',
                                  fit: BoxFit.contain,
                                ),
                              ),
                              SizedBox(
                                width: 200,
                                height: 50,
                                child: Center(
                                  child: Text('CHILD GAME', style: MyStyles.primaryButtonStyle,),
                                ),
                              )
                            ],
                          ),
                        ),),
                        SizedBox(height: 30,),
                        Text('NEW TESTAMENT:\nTHE AI EXPERIENCE', style: const TextStyle(
                            fontSize: 50, color: Colors.white, fontFamily: 'Jomhuria', height: 0.5), textAlign: TextAlign.center,),
                        Center(child: GestureDetector(
                          onTap: () async{
                            String userName = await _showUsernameInputDialog(context);
                            if(userName.isNotEmpty){
                              Navigator.push(
                                context,
                                MaterialPageRoute(
                                  builder: (_) => ChatScreen(gameMode: 'paid',userName:userName, gameTitle: 'NEW TESTAMENT:THE AI EXPERIENCE', promptUrl: 'https://aibiblegames.com/gp2/newgame.txt',),
                                ),
                              );
                            }

                          },
                          child: Stack(
                            children: [
                              SizedBox(
                                width: 200,
                                height: 50,
                                child: Image.asset(
                                  'assets/bg_btn.png',
                                  fit: BoxFit.contain,
                                ),
                              ),
                              SizedBox(
                                width: 200,
                                height: 50,
                                child: Center(
                                  child: Text('PLAY GAME', style: MyStyles.primaryButtonStyle,),
                                ),
                              )
                            ],
                          ),
                        ),),
                        SizedBox(height: 20,),
                        Text('NEW TESTAMENT:\nTRIVIA CHALLENGE', style: const TextStyle(
                            fontSize: 50, color: Colors.white, fontFamily: 'Jomhuria', height: 0.5), textAlign: TextAlign.center,),
                        Center(child: GestureDetector(
                          onTap: () async{
                            String userName = await _showUsernameInputDialog(context);
                            if(userName.isNotEmpty){
                              Navigator.push(
                                context,
                                MaterialPageRoute(
                                  builder: (_) => ChatScreen(gameMode: 'paid',userName:userName, gameTitle: 'NEW TESTAMENT: TRIVIA CHALLENGE', promptUrl: 'https://aibiblegames.com/gp2/quiz.txt',),
                                ),
                              );
                            }

                          },
                          child: Stack(
                            children: [
                              SizedBox(
                                width: 200,
                                height: 50,
                                child: Image.asset(
                                  'assets/bg_btn.png',
                                  fit: BoxFit.contain,
                                ),
                              ),
                              SizedBox(
                                width: 200,
                                height: 50,
                                child: Center(
                                  child: Text('PLAY GAME', style: MyStyles.primaryButtonStyle,),
                                ),
                              )
                            ],
                          ),
                        ),),
                      ],
                    ),
                  ),
                ),
              ),
            ],
          ),

        ),
      // body: Container(
      //   height: MediaQuery.of(context).size.height,
      //   width: MediaQuery.of(context).size.width,
      //   child: SingleChildScrollView(
      //     child: ListBody(
      //       children: [
      //         ListTile(title: Text('Adult\'s Game'),onTap: (){
      //           Navigator.push(
      //             context,
      //             MaterialPageRoute(
      //               builder: (_) => ChatScreen(gameMode: 'paid',userName:userName, gameTitle: 'Adult Game'),
      //             ),
      //           );
      //         }, subtitle: Text('Play the adult\'s game'),),
      //         ListTile(title: Text('Child\'s Game'),onTap: (){
      //           Navigator.push(
      //             context,
      //             MaterialPageRoute(
      //               builder: (_) => ChatScreen(gameMode: 'paid',userName:userName, gameTitle: 'Child Game', promptUrl: 'https://aibiblegames.com/gp2/jesus28.txt',),
      //             ),
      //           );
      //         }, subtitle: Text('Play the children\'s game'))
      //       ],
      //     ),
      //   ),
      // ),
    );
  }


  _showUsernameInputDialog(BuildContext context) async {
    String username = '';

    var result = await showDialog(
      context: context,
      builder: (BuildContext context) {
        return AlertDialog(
          backgroundColor: Colors.white,
          title: Text('Enter Your Name'),
          content: TextFormField(
            decoration: InputDecoration(labelText: 'Name'),
            onChanged: (value) {
              username = value;
            },
          ),
          actions: <Widget>[
            TextButton(
              child: Text('Cancel'),
              onPressed: () {
                Navigator.of(context).pop("");
              },
            ),
            TextButton(
              child: Text('Play'),
              onPressed: () {
                // Use the entered username (in the 'username' variable)
                if (username.isNotEmpty) {
                  print('Username: $username');
                  Navigator.of(context).pop(username);
                } else {
                  CommonUtils.showToast("Please enter your name");
                  // You can add an error message or validation logic here
                }
              },
            ),
          ],
        );
      },
    );
    return result;
  }
}