import 'package:aibiblegames/pages/HomeScreen.dart';
import 'package:aibiblegames/utils/CommonUtils.dart';
import 'package:firebase_auth/firebase_auth.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:loader_overlay/loader_overlay.dart';

class LoginScreen extends StatefulWidget{
  @override
  State<LoginScreen> createState() => _LoginScreenState();

}

class _LoginScreenState extends State<LoginScreen>{
  TextEditingController emailController = TextEditingController();
  TextEditingController passwordController = TextEditingController();

  @override
  void initState() {
    FirebaseAuth.instance
        .authStateChanges()
        .listen((User? user) {
      if (user != null) {

        Navigator.pushReplacementNamed(context,'/home');
      }
    });
    super.initState();
  }
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      backgroundColor: Colors.white,
      body: SingleChildScrollView(
        child: Column(
          children: <Widget>[
            Padding(
              padding: const EdgeInsets.only(top: 60.0),
              child: Center(
                child: Container(
                    width: 200,
                    height: 150,
                    /*decoration: BoxDecoration(
                        color: Colors.red,
                        borderRadius: BorderRadius.circular(50.0)),*/
                    child: Image.asset('assets/logo.png')),
              ),
            ),
            SizedBox(height: 30,),
            Padding(
              //padding: const EdgeInsets.only(left:15.0,right: 15.0,top:0,bottom: 0),
              padding: EdgeInsets.symmetric(horizontal: 15),
              child: TextField(
                controller: emailController,
                decoration: InputDecoration(
                    border: OutlineInputBorder(),
                    labelText: 'Email',
                    hintText: 'Enter valid email'),
              ),
            ),
            Padding(
              padding: const EdgeInsets.only(
                  left: 15.0, right: 15.0, top: 15, bottom: 0),
              //padding: EdgeInsets.symmetric(horizontal: 15),
              child: TextField(
                controller: passwordController,
                obscureText: true,
                decoration: InputDecoration(
                    border: OutlineInputBorder(),
                    labelText: 'Password',
                    hintText: 'Enter secure password'),
              ),
            ),
            SizedBox(height: 30,),
            // ElevatedButton(
            //   onPressed: (){
            //     //TODO FORGOT PASSWORD SCREEN GOES HERE
            //   },
            //   child: Text(
            //     'Forgot Password',
            //     style: TextStyle(color: Colors.blue, fontSize: 15),
            //   ),
            // ),
            Container(
              height: 50,
              width: 250,
              decoration: BoxDecoration(
                  color: Colors.blue, borderRadius: BorderRadius.circular(20)),
              child: ElevatedButton(
                onPressed: () async{
                  if(emailController.text.isNotEmpty && passwordController.text.isNotEmpty){
                    context.loaderOverlay.show();
                    try {
                      UserCredential userCredential = await FirebaseAuth.instance.signInWithEmailAndPassword(
                          email: emailController.text,
                          password: passwordController.text,
                      );
                      if(userCredential.user?.emailVerified == false){
                        CommonUtils.showToast("Please verify your email.");
                      }
                      context.loaderOverlay.hide();
                    } on FirebaseAuthException catch (e) {
                      context.loaderOverlay.hide();
                      if (e.code == 'user-not-found') {
                        CommonUtils.showToast('No user found for that email.');
                      } else if (e.code == 'wrong-password') {
                        CommonUtils.showToast('Wrong password provided for that user.');
                      }
                      else{
                        CommonUtils.showToast(e.message ?? e.code);
                      }
                    }
                    catch(e){
                      context.loaderOverlay.hide();
                      CommonUtils.showToast(e.toString());
                    }
                  }
                  else{
                    CommonUtils.showToast("Please enter your email and password.");
                  }
                },
                child: Text(
                  'Login',
                  style: TextStyle(color: Colors.white, fontSize: 25),
                ),
              ),
            ),
            SizedBox(
              height: 130,
            ),
            Row(
              children: [
                Expanded(child: SizedBox()),
                Text('New User?'),
                InkWell(child: Text(' Create Account'), onTap: (){
                  Navigator.pushReplacementNamed(context, '/signup');
                },),
                Expanded(child: SizedBox()),
              ],
            )
          ],
        ),
      ),
    );
  }

}