import 'package:aibiblegames/pages/GamesScreen.dart';
import 'package:aibiblegames/pages/SplashScreen.dart';
import 'package:aibiblegames/pages/SubscriptionsScreen.dart';
import 'package:aibiblegames/pages/auth/LoginScreen.dart';
import 'package:aibiblegames/pages/auth/SignUpScreen.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:fluttertoast/fluttertoast.dart';
import 'package:http/http.dart' as http;

import '../pages/HomeScreen.dart';

class CommonUtils{
  static dynamic returnRoutes(BuildContext context){
    return {
      '/home': (context) => HomeScreen(),
      '/login': (context) => LoginScreen(),
      '/signup': (context) => SignUpScreen(),
      '/subscriptions': (context) => SubscriptionsScreen(),
      '/games': (context) => GamesScreen(),
      '/splash': (context) => SplashScreen()
    };
  }
  static Future<int?> getFileSizeFromUrl(String url) async {
    try {
      // Making a HEAD request to the file URL
      final response = await http.head(Uri.parse(url));

      // If the call to the server was successful, parse the file size from the headers
      if (response.statusCode == 200) {
        return int.parse(response.headers['content-length'] ?? '0');
      } else {
        print('Failed to load file size. Status code: ${response.statusCode}');
        return null;
      }
    } catch (e) {
      print('An error occurred: $e');
      return null;
    }
  }
  static void showToast(String message){
    Fluttertoast.showToast(
        msg: message,
        toastLength: Toast.LENGTH_SHORT,
        gravity: ToastGravity.CENTER,
        timeInSecForIosWeb: 1,
        backgroundColor: Colors.green,
        textColor: Colors.white,
        fontSize: 16.0
    );
  }
  static Future<String> fetchData(String url) async {
    final response = await http.get(Uri.parse(url));

    if (response.statusCode == 200) {
      return response.body;
    } else {
      throw Exception('Failed to load text file');
    }
  }

  static basicGreenButtonShape() {
    return RoundedRectangleBorder(
      // side: BorderSide(color: Colors.primaries.first),
      borderRadius: BorderRadius.circular(8.0),
    );
  }
}